
#import "rec.h"
// #import "rectbl.h"
#import "GrabBag.h"  
#import "nxlcau33.h"
#import <string.h> 
 
extern  int binrule[KK][KK][KK][KK][KK][KK][KK];
// extern  double qcntr[][2];
extern  char   arr1[128][128], arr2[AL];
 
char   va[KK] = {'p', 'q'};

extern int    co, dn;		/* connectivity, dimension */

void asctobin();
int  eq01(int i, int j);
int  eq02(int i, int j);
int  eq03(int i, int j); 
int  frac1(int a);
void runowows(char x[2][2][2], int n);
int  wolbin(int a, int b); 
int  wowsruno(char ru[2][2][2]);
extern unsigned long int wru();
int rec(char *z);
extern int rec_c(char *z, Inst rprg, int l, struct fptbl dtbl[]);
extern int rec_x(Inst rprg);

extern Inst xprg[10][XLEN];
extern char idef[][30]; 
extern char  reverdemo[4][CLEN];
int phil;              /* length of cstr */

 Inst rprg[900];  /*PLEN*/
 char cstr[300];  /*CLEN*/

char *filename;
extern struct fptbl dtbl[];
extern char cstr[];
/*extern Inst rprg;  */
 

@implementation GrabBag

/* ------------ */
/*   ------     REC  program   management   ---------    */

- loadRECWindow:sender { 
  [thisWin makeKeyAndOrderFront: sender];
  [self loadInternal: sender];
  return self;
}

- loadExternal:sender { 
[self loadLowPanel:externalRECBox];
 return self;
} 

- loadInternal:sender { 
[self loadLowPanel:internalRECBox];
 return self;
}

- loadLowPanel:thisRECBox
{ NXRect bx1Rect, lo1Rect;
  [theBigBox  getFrame:&bx1Rect];
  [thisRECBox getFrame:&lo1Rect];
  [theBigBox  setContentView: [thisRECBox contentView]];
  lo1Rect.origin.x = (bx1Rect.size.width - lo1Rect.size.width)/2.0;
  lo1Rect.origin.y = (bx1Rect.size. height - lo1Rect.size.height)/2.0;
  [theLilBox setFrame: &bx1Rect];
  [theLilBox display];
  [theBigBox display];
 return self;
}


- runREC:sender { 
  [value setStringValue: "  "];
  [value setStringValue: (rec(cstr))?"T":"F"];
  return  self;
}

- rerunREC:sender {
   [xtrnWin getSubstring: cstr start: 0 length: [xtrnWin textLength]];
   if (vFlags.needsDisplay)
   [thisWin setDocEdited: YES];
return self;
}

/* - - - - - - - - - - -    T E X T    D E L E G A T E    - - - - - - - - - */

- textDidChange:sender {
  [thisWin setDocEdited: YES];
  return self;
}


/* - - - - - - - - - - -  B R O W S E R   D E L E G A T E  - - - - - - - - - */

- (int) browser: sender fillMatrix: matrix inColumn: (int)col { int i, n;
    n=0;
    switch (col) {
	case 0:
	    for(i=0; i<3; i++) {
		[matrix addRow];
		[[ matrix cellAt: i: 0] setLeaf: NO];
		[[ matrix cellAt: i: 0] setLoaded: YES];
		[[ matrix cellAt: i: 0] setEnabled: YES];
			}
		[[ matrix cellAt: 0: 0] setStringValue: "operators"];
		[[ matrix cellAt: 1: 0] setStringValue: "predefinided"];
		[[ matrix cellAt: 2: 0] setStringValue: "demonstrations"];
		n=3;
	     break;
	case 1:
	if (strcmp((char *)[[sender selectedCell] stringValue], 
		"predefined")==0){
	   for(i=0; i<1; i++) { 
		[ matrix addRow];
		[[matrix cellAt: i: 0] setStringValue: idef[i]];
		[[ matrix cellAt: i: 0] setLeaf: YES];
		[[ matrix cellAt: i: 0] setLoaded: YES];
		[[ matrix cellAt: i: 0] setEnabled: YES];
		}
		n=1;              }
	if (strcmp((char *)[[sender selectedCell] stringValue], 
		"operators")==0){
	   for(i=0; i<95; i++) { 
		[ matrix addRow];
		[[matrix cellAt: i: 0] setStringValue: dtbl[i].r_cmnt];
		[[ matrix cellAt: i: 0] setLeaf: YES];
		[[ matrix cellAt: i: 0] setLoaded: YES];
		[[ matrix cellAt: i: 0] setEnabled: YES];
		}
		n=95;             }
	    break;
	default: n=0; break; }
     return n; 
   }



/* - - - - - - -  F I L E   A N D    D I R E C T O R Y   - - - - - - - - - - */

- setFilename:(const char *)aFilename {
   if (filename) free(filename);
   filename = malloc(strlen(aFilename)+1);
   strcpy(filename,aFilename);
   [thisWin setTitleAsFilename:filename];
   return self;
}

- open:sender { char *types[2] = {"gph",0};
  int i, fd;
  double x, y;
  NXStream *theStream;
  printf("hello from open\n");
    [[OpenPanel new] allowMultipleFiles: NO];
    [[OpenPanel new] chooseDirectories : NO];

    if ([[OpenPanel new] runModalForTypes:types]){
	[self setFilename: [[OpenPanel new] filename]];
	fd=open(filename, O_RDONLY, 06666);
	theStream=NXOpenFile (fd, NX_READONLY);
//	for (i=0; i<128; i++) 
//	  NXScanf(theStream,"%lf%lf",&qcntr[i][0],&qcntr[i][1]);
	NXClose(theStream);
	close(fd);
//	[thisWin setTitleAsFilename: filename];
//	[thisWin setDocEdited: NO];
	  }
return self;
}

- saveAs: sender { id panel;
  const char *dir;
  char *file;

    /* prompt user for a file name and save to that file  */
  if  (filename==0) {
   /*  no file name; set up defaults       */
  dir = NXHomeDirectory();
  file = (char *)[thisWin title];
  } else {
  file = rindex(filename, '/');
  if (file) {
     dir = filename;
     *file = 0;
      file++;
     } else {
     dir = filename;
     file = (char *)[thisWin title];
     }
   }
  panel = [SavePanel new];
  [panel setRequiredFileType: ""];
  if ([panel runModalForDirectory: dir file: file]) {
	[self setFilename: [panel filename]];
  return [self save:sender];
  }
  return nil;   /* didn't save */
}

- save:sender { 
  int i;
  int fd;
  NXStream *theStream;
  if (filename==0) return [self saveAs: sender];
  [thisWin setTitle: "saving... "];

  fd=open(filename,O_WRONLY | O_CREAT | O_TRUNC, 06666);
  if (fd < 0) {
	NXRunAlertPanel(0," cannot save file: %s",0,0,0,strerror(errno));
        return self;
	}
  theStream = NXOpenFile(fd, NX_WRITEONLY);
//   for (i=0; i<128; i++) 
//	NXPrintf(theStream,"%6.3f %6.3f\n",qcntr[i][0],qcntr[i][1]);   
  NXClose(theStream);
  close(fd);
//  [thisWin setTitleAsFilename: filename];
//  [thisWin setDocEdited: NO];
  return self;
 }


- close :sender {
/* const char *fname;*/
  int q=0;
  if ([thisWin isDocEdited])
//  fname=filename ? filename : [sender title];
//  if (rindex(fname,'/')) fname=rindex(fname,'/')+1;

    q = NXRunAlertPanel("Save","Save changes to %s?","Save","Don't save","Cancel",filename);
  if (q== 1) { if (![self save:nil]) return nil;}
  if (q==-1) return nil;
// [sender setDelegate: nil];
// [proc free];
// [self free];


return self;
}

- windowWillClose:sender { 
 [self close: self];
 printf("windowWillClose\n");
 return self;
}

- openLife:sender
{ char *types[2] = {"lif",0};
  char c, h[72], arr[100][100];
  int x, y;
  int i, j, k, n, x0, y0, fd;
  NXStream *theStream;
  printf("hello from openLife\n");
    [[OpenPanel new] allowMultipleFiles: NO];
    [[OpenPanel new] chooseDirectories : NO];

    if ([[OpenPanel new] runModalForTypes:types]){
	[self setFilename: [[OpenPanel new] filename]];
	fd=open(filename, O_RDONLY, 06666);
	theStream=NXOpenFile (fd, NX_READONLY);
	NXSeek(theStream, 0, NX_FROMSTART);
	zerline();
	i=0; while ((h[i]=NXGetc(theStream))!='\n') i++;
	h[i]=0;
	[planeTitle setStringValue: h];
	[planeBox setTitle:"Life Pattern"];
	NXScanf(theStream,"x =%d, y =%d",&x,&y);
	x0=64-x/2;
	y0=64-y/2;
	i=0; j=0; n=0;
	while ((c=NXGetc(theStream))!='!') {
       if (c=='b') {for (k=0; k<(n==0?1:n); k++, i++) arr1[i+x0][j+y0]=0; n=0;}
  else if (c=='o') {for (k=0; k<(n==0?1:n); k++, i++) arr1[i+x0][j+y0]=1; n=0;}
  else if (c=='$') {for (k=0; k<(n==0?1:n); k++) j++; i=0; n=0;}
  else if (isdigit(c)) n=10*n+c-'0';
	  }

	NXClose(theStream);
	close(fd);
	  }
return self;
}

/* File has one line header followed by the Life figure */
- openShortLife:sender
{ char *types[2] = {"shl",0};
  char c, h[72], arr[100][100];
  int x, y;
  int i, j, k, fd;
  NXStream *theStream;
  printf("hello from openShortLife\n");
    [[OpenPanel new] allowMultipleFiles: NO];
    [[OpenPanel new] chooseDirectories : NO];

    if ([[OpenPanel new] runModalForTypes:types]){
	[self setFilename: [[OpenPanel new] filename]];
	fd=open(filename, O_RDONLY, 06666);
	theStream=NXOpenFile (fd, NX_READONLY);
	NXSeek(theStream, 0, NX_FROMSTART);
	zerline();
	i=0; while ((h[i]=NXGetc(theStream))!='\n') i++;
	h[i]=0;
	[planeTitle setStringValue: h];
	[planeBox setTitle:"Life Pattern"];
	i=0; j=0;
	while ((c=NXGetc(theStream))!=EOF) {
       if (c=='.'||c==' ') {arr1[i+30][j+30]=0; i++;}
  else if (c=='*'||c=='o') {arr1[i+30][j+30]=1; i++;}
  else if (c=='\n') {i=0; j++;}
	  }

	NXClose(theStream);
	close(fd);
	  }
return self;
}

/* to distract the single click in a browser double click */
- nhul: sender {return self;}


/* - - - - - - - - - - - - R E C   p r o g r a m s - - - - - - - - - - - - -*/	

- doRec:sender {}

- copyAndRunREC:sender {}


/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - - - - -   O R D E R   R E L A T I O N S   - - - - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- showSubText: (char *)ch {int tl;
  tl=[subText textLength];
  [subText setSel: tl: tl];
  [subText replaceSel:  ch];
  [subText scrollSelToVisible];
  [subText display];
return self;
}

/* check the indices for all the subsets */
- subAut:sender {
asctobin();
  [self showSubText: "Subset indices:\n\n"];
  [self showSubText: "(012)27/27\n\n"];
  [self twos];
  [self showSubText: "\n"];
  [self ones];
printf("goodbye from subAut\n");
return self;
  }

/* check the two-element subsets */
- twos {
char ch[30];
int  k, l, frac2(), wolbin();

  k=wolbin(0,1);
  l= frac2(0,1);
  if (k<256) sprintf(ch,"(01)   %2d/ 8  %3d\n",l,k);
        else sprintf(ch,"(01)   %2d/ 8\n",l); 
  [self showSubText: ch];

  k=wolbin(0,2);
  l= frac2(0,2);
  if (k<256) sprintf(ch,"(02)   %2d/ 8  %3d\n",l,k);
        else sprintf(ch,"(02)   %2d/ 8\n",l); 
  [self showSubText: ch];

  k=wolbin(1,2);
  l= frac2(1,2);
  if (k<256) sprintf(ch,"(12)   %2d/ 8  %3d\n",l,k);
        else sprintf(ch,"(12)   %2d/ 8\n",l); 
  [self showSubText: ch];

return self;
}

/* calculate fraction of neighborhoods which conserve the evolution */
/* of a particular two element subset and report this as an index */

int frac2(a,b) int a, b; {int k, i0, i1, i2, s[2], isab();
k=0; s[0]=a; s[1]=b;
for (i0=0; i0<2; i0++)
for (i1=0; i1<2; i1++)
for (i2=0; i2<2; i2++)
  if (isab(a,b,binrule[s[i0]][s[i1]][s[i2]])) k++;
return k;
}

/* check membership in two-element set */
int isab(a,b,i) int a, b, i; {return (i==a||i==b);}

/* check whether one-element subset is closed */
- ones {
char ch[20];
int  frac1();
sprintf(ch,"(0)    %2d/ 1\n",frac1(0)); [self showSubText: ch];
sprintf(ch,"(1)    %2d/ 1\n",frac1(1)); [self showSubText: ch];
sprintf(ch,"(2)    %2d/ 1\n",frac1(2)); [self showSubText: ch];
return self;
}

/* calculate fraction of neighborhoods which conserve the evolution */
/* of a particular one element subset and report this as an index */
int frac1(a) int a; {int k; k=0; if (a==(int)binrule[a][a][a][a][a]) k++; return k;}

/* ascertain the Wolfram Rule Number of a two-state subautomaton */

int wolbin(a,b) int a, b; {
char ru[2][2][2];
int  k, i0, i1, i2, s[2], eq[KK], isab();
s[0]=a; s[1]=b;
eq[a]='0'; eq[b]='1';
for (i0=0; i0<2; i0++)
for (i1=0; i1<2; i1++)
for (i2=0; i2<2; i2++) {
  k=(int)binrule[s[i0]][s[i1]][s[i2]];
  if (k==a || k==b) ru[i0][i1][i2]=eq[k]; else return 256;
  }
return wowsruno(ru);
}

/* turn two-state ascrule into its two-state Wolfram number */
int wowsruno(ru) char ru[2][2][2]; {
/*char xx[10];*/
int  k, i0, i1, i2;
  k=0;
  for (i0=1; i0>=0; i0--)
  for (i1=1; i1>=0; i1--)
  for (i2=1; i2>=0; i2--) {
    k=2*k+ru[i0][i1][i2]-'0';
    }
  return k;
}

/* turn two-state Wolfram number into 2x2x2 ascrule */
void runowows(x,n) char x[2][2][2]; int n; {
int i, i0, i1, i2;
  i=n;
  for (i0=0; i0<2; i0++) 
  for (i1=0; i1<2; i1++) 
  for (i2=0; i2<2; i2++) {
    x[i0][i1][i2]=i%2+'0';
    i/=2;
    }
}

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - - - - - - -   E Q U I V A L E N C E   R E L A T I O N S   - - - - - - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- showEquText: (char *)ch {int tl;
  tl=[equText textLength];
  [equText setSel: tl: tl];
  [equText replaceSel:  ch];
  [equText scrollSelToVisible];
  [equText display];
return self;
}

/* calculate equivalence relation indices */

- equAut:sender {
char   ch[20];
int    i, j, i0, i1, i2, i3, i4, i5, q[5], t[5];
double r[5];
asctobin();
for (i=0; i<5; i++) q[i]=t[i]=0;
for (i0=0; i0<KK; i0++)
for (i1=0; i1<KK; i1++)
for (i2=0; i2<KK; i2++)
for (i3=0; i3<KK; i3++)
for (i4=0; i4<KK; i4++)
for (i5=0; i5<KK; i5++)
  {
  i=(int)binrule[i0][i1][i2];
  j=(int)binrule[i3][i4][i5];
  q[0]++;
  if (eq01(i0,i3)&&eq01(i1,i4)&&eq01(i2,i5)) {t[1]++; if (eq01(i,j)) q[1]++;}
  if (eq02(i0,i3)&&eq02(i1,i4)&&eq02(i2,i5)) {t[2]++; if (eq02(i,j)) q[2]++;}
  if (eq03(i0,i3)&&eq03(i1,i4)&&eq03(i2,i5)) {t[3]++; if (eq03(i,j)) q[3]++;}
  q[4]++;
  }
r[0]=1.0;
for (i=1; i<4; i++) r[i]=((double)q[i])/((double)t[i]);
r[4]=1.0;
		       [self showEquText:"Equivalence indices\n"];
sprintf(ch,"(012)       %5.3f\n",r[0]); [self showEquText: ch];
sprintf(ch,"(0)(12)     %5.3f\n",r[1]); [self showEquText: ch];
sprintf(ch,"(1)(02)     %5.3f\n",r[2]); [self showEquText: ch];
sprintf(ch,"(2)(01)     %5.3f\n",r[3]); [self showEquText: ch];
sprintf(ch,"(0)(1)(2)   %5.3f\n",r[4]); [self showEquText: ch];
printf("goodbye from equAut\n");
return self;
}

int eq01(i,j) int i, j; {return ((i==0&&j==0)||(i!=0&&j!=0));}
int eq02(i,j) int i, j; {return ((i==1&&j==1)||(i!=1&&j!=1));}
int eq03(i,j) int i, j; {return ((i==2&&j==2)||(i!=2&&j!=2));}

/* ------------- */

/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* - -   G E N E R A T E   M A T H E M A T I C A   I N T E R F A C E S   - - */
/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

- matica:sender {
char ch[60];   
int  tl, gbns;
int  i, j, k, i0, i1, i2, i3, i4, w[KK], c[KK][RR+1];
/*[KK+1][KK+1][KK+1];*/
  gbns=0;
  if (strcmp([sender title],"Groebner Basis")==0) gbns=YES;
  if (strcmp([sender title],"NSolve")==0)         gbns=NO;
// ++++++++++++++++++++++++++++++++ //
  sprintf(ch,"%11u",wru());
  [ruleNumber setStringValue: ch];
for (i0=0; i0<KK; i0++) for (i1=0; i1<RR+1; i1++)
/* for (i2=0; i2<KK+1; i2++)  for (i3=0; i3<KK+1; i3++) for (i4=0; i4<KK+1; i4++) */
	c[i0][i1]=0;
for (i0=0; i0<KK; i0++) for (i1=0; i1<KK; i1++) 
for (i2=0; i2<KK; i2++) for (i3=0; i3<KK; i3++) for (i4=0; i4<KK; i4++)
/* aux[i0+i1+i2+i3+i4]=binrule[i0][i1][i2][i3][i4];
 
for (i0=0; i0<KK; i0++) for (i1=0; i1<RR+1; i1++)  */

 {
  w[0]=w[1]=0;  /*w[2]=w[3]=w[4]=0;*/
  w[i0]++; w[i1]++; w[i2]++; w[i3]++; w[i4]++; 
  (c[(int)binrule[i0][i1][i2][i3][i4]][w[0]])++;/*[w[1]][w[2]][w[3]])++;*/
  }
if (gbns) sprintf(ch,"GroebnerBasis[{\n"); else sprintf(ch,"NSolve[{\n");
  tl=[groeText textLength];
  [groeText setSel: 0: tl];
  [groeText replaceSel:  ch];
  [groeText scrollSelToVisible]; 
  [groeText display];
for (i=0; i<KK; i++) {
  k=0;
  for (i1=0; i1<RR+1; i1++)
/* for (i2=0; i2<RR+1; i2++) */
{
    if (5 < i1) continue;
     /* if (3 < i1+i2) continue;  */
    j=c[i][i1]; /*[i2][i3][i4];  */
    if (j == 0) continue;
    if (k > 0) {
	 sprintf(ch," + ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (j > 1) {
	 sprintf(ch,"%d " ,j);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i1==1) {
	 sprintf(ch,"p ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i1 > 1) {
	 sprintf(ch,"p^%d ",i1);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
  i2=5-i1;
    if (i2==1) {
	 sprintf(ch,"q ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i2 > 1) {
	 sprintf(ch,"q^%d ",i2);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
 /*   i3=3-i1-i2;
    if (i3==1) {
	 sprintf(ch,"r ");
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }
    if (i3 > 1) {
	 sprintf(ch,"r^%d ",i3);
         tl=[groeText textLength];
         [groeText setSel: tl: tl];
         [groeText replaceSel:  ch];
         [groeText scrollSelToVisible]; 
         [groeText display];
	 }*/
    k++;
    }
  if (gbns) sprintf(ch," - %c,\n",va[i]);
	 else sprintf(ch," - %c == 0,\n",va[i]);
  tl=[groeText textLength];
  [groeText setSel: tl: tl];
  [groeText replaceSel:  ch];
  [groeText scrollSelToVisible]; 
  [groeText display];
  } 
if (gbns) sprintf(ch,"p + q - 1\n},{p, q}]\n");
	else sprintf(ch,"p + q - 1 == 0\n},{p, q}]\n");
  tl=[groeText textLength];
  [groeText setSel: tl: tl];
  [groeText replaceSel:  ch];
  [groeText scrollSelToVisible]; 
  [groeText display];

// ++++++++++++++++++++++++++++++++ //

return self;
}

@end

/* end GrabBag.m */