/* 
 * BruiView.h -- Interface file for the BruiView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to its
 * fitness for any particular use, nor even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface BruiView:View
{

	id		dbBranches;
	id		dbNode;
	id		dragStyle;
	id		evWindow;
	id		evButton;
	id		guphView;
	id		labelStyle;
	id		leaveTrail;
	id		linkAge;
	id		moveWhich;
	id		nodeNumber;
	id		selfLinks;
	id		treeShow;
	id		ruleNumber;
	id		trailText;
	id		trailWindow;
	id		trivGnrl;
	id		trivNode;
	id		underDiagram;
	id		whichConstant;
	id		whichPermutation;
	id		sh0;
	id		sh1;
	id		sh2;
	id		whichWidth;
	id		zeroLinks;

/*  de Bruijn window		*/
	id		db2Window;

	id		wholePanel;
	id		timeDate;
	
	id		delegate;
	id		crossCursor;

	char		*filename;
	char		**filenames;

}

- close:sender;
- dbWindow:sender;
- locAte:sender;
- bruiConst:sender;
- bruiShift:sender;
- openBrui:sender;
- printBrui:sender;
- redrawBrui:sender;
- bruiMove:sender;
- bruiReset:sender;
- runBrui:sender;
- saveBrui:sender;
- saveBruiAs:sender;
- setRuTriv;
- showBrui:sender;
- showTrail:sender;

- initFrame:(const NXRect *)frameRect;
- setDelegate:anObject;
- drawSelf:(const NXRect *)rects :(int)rectCount;
- sizeTo:(NXCoord)width :(NXCoord)height;
- mouseDown:(NXEvent *)theEvent;

@end
