
/* 
 * LCAUView.h -- Interface file for the LCAUView class 
 *
 * You may freely copy, distribute, and reuse the code in this example.
 * NeXT disclaims any warranty of any kind, expressed or implied, as to 
 * its fitness for any particular use, or even that it has a use.
 *
 */

#import <appkit/appkit.h>

@interface OverAll:View {

	id		tiDat;
	id		toFullNumber;

	id		ardnPanel;
	id		colorPanel;
	id		pairPanel;
	id		rulePanel;
	id		ssetPanel;

	id		dbguph;

	id		inCol0;
	id		inCol1;
	id		inCol2;

	id		theWellBox;

	id		menuArdn;
	id		menuColor;
	id		menuCopy;
	id		menuPair;
	id		menuSset;

	id		browser;

	id 		RECLine;
	id		RECValue;
	id		RECPanel;

	id		ruinView;
	id		rijnView;

	id		dimenMenu;
	id		dimenPrefs;

}

- copyWells:sender;
- revertColors:sender;
- saveColors:sender;
- updateColors; 

- loadOverAll:sender;

- dbWindow:sender;
- dimenChoice:sender;
- setDimension:sender;

@end

/* end OverAll.h */
