
/* nxprob32.h						*/
/* program for lcau32 option 't'			*/
/* calculate probabilities related to evolution		*/


/* from prob.c */
void   asfreq(int l);
void   bdot(int i, int j, int l);
void   bgraf(int n);
void   bpanel();
void   dbgraf(int n);
double dsqsu(double t[KK]);
double fsqsu(double t[KK]);
void   gdiag(int n);
void   gfram(int x, int y, int n);
void   ggrid(int n);
void   gnlsum(int ll, int mm, int nn);
void   gnrsum(int mm, int b[KK][KK][KK]);
void   lgraf(int n);
void   lifreq(int n, int l);
void   linegrid(int n);
int    lnco(double t, int i);
void   moncar(int n, int l);
void   lpanel();
void   nblclr();
void   nblcur(int n);
void   nbrsum(int ll, int mm, int nn);
void   neisum(int ll, int mm, int nn);
void   onesum(int mm, int cc, int *b);
void   pddiff(int n, int l);
void   pdiff(int n, int l);
void   pdot(int i, int j, int l);
void   penry(int n);
void   pevolve();
void   pfdiff(int n, int l);
void   pidiff(int n, int l, int f);
void   psddiff(int n, int l);
void   ptdiff(int n, int l);
void   pvdiff(int n, int l);
double sdsqsu(double t[KK]);
void   spdiff(int n, int l);
int    sqco(double t, int i);
double sqsu(double t[KK]);
void   tbgraf(int n);
void   trmenu();
double tsqsu(double t[KK]);
double vbern(int i, double t[KK]);
void   videostdot(int u, int v, double x[KK], double t, int l);
void   videotrdot(double t[KK], int l);
void   videotrgrid(int n, int l);
void   videotrli(double a, double b, double c, int l);
void   videotrline(double t[KK], int l);
double vsqsu(double t[KK]);
void   xlinegrid(int n);
void   xpdiff(int n, int l);

/* end nxprob32.h */
